//////////////////////////    скетч для управления 8 сервоприводами квадропода   /////////////////
#include <Servo.h> //используем библиотеку

Servo myservoK3 ;  //указываем сервопривод заднего левого колена
Servo myservoB4;  //указываем сервопривод  заднего левого бедра
Servo myservoK5 ;  //указываем сервопривод переднего левого колена
Servo myservoB6;  //указываем сервопривод  переднего левого бедра
Servo myservoK7 ;  //указываем сервопривод заднего правого колена
Servo myservoB8;  //указываем сервопривод  заднего правого бедра
Servo myservoK9 ;  //указываем сервопривод переднего правого колена
Servo myservoB10;  //указываем сервопривод переднего правого бедра

int n=15;//единица временного интервала
int a03=110;int a04=75;int a05=55;int a06=97;int a07=80;int a08=75;int a09=73;int a010=85;//переменные для углов начального положения конечностей
int da=10;//переменная амплитуды изменения угла в градусах для колен
int db=12;//переменная амплитуды изменения угла в градусах для бёдер
int i;
int a3=a03;int a4=a04;int a5=a05;int a6=a06;int a7=a07;int a8=a08;int a9=a09;int a10=a010;// переменные для хранения значений текущих углов
//////при увеличении значения угла сервоприводы движут лапы :B4,B6-вперёд B8,B10-назад K3,K9-вниз K5,K7-вверх ////////
////////////////////////////////
String inputString;// строки данных
byte K=2;//счётчик выбора  команд для движений
boolean f=true;//переменная для флага
byte r=0;// счётчик для пауз в мигании подсветки при остановке квадропода
////////////////////////////////
const int echoPin=11; //ВЫВОДЫ ПОД УЗ ДАТЧИК
const int trigPin=12;
unsigned int x,x1;// ПЕРЕМЕННЫЕ ДЛЯ РАБОТЫ С УЗ ДАТЧИКОМ
//////////////////////////////// 
void setup()
{
////////////////////////////////
pinMode(2, OUTPUT);//ВЫВОД ДЛЯ УПРАВЛЕНИЯ ПОДСВЕТКОЙ СВЕТОДИОДНОЙ 
digitalWrite(2,LOW);
//////////////////////////////// 
pinMode(trigPin, OUTPUT); 
pinMode(echoPin, INPUT);
digitalWrite(trigPin, LOW); 
Serial.begin(9600);
////////////////////////////////////////////
myservoK3.attach(3);//выводы  для подключения 1-8 сервоприводов
myservoB4.attach(4);
myservoK5.attach(5); 
myservoB6.attach(6); 
myservoK7.attach(7);
myservoB8.attach(8);
myservoK9.attach(9); 
myservoB10.attach(10); 

myservoK3.write(a03); delay(n);// начальная установка-настройка углов поворота валов серв
myservoB4.write(a04); delay(n);
myservoK5.write(a05); delay(n);
myservoB6.write(a06); delay(n);
myservoK7.write(a07); delay(n);
myservoB8.write(a08); delay(n);
myservoK9.write(a09); delay(n);
myservoB10.write(a010); delay(n);


delay(250*n);
}

void loop()
{
  CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ НА ИЗМЕНЕНИЕ ВЫПОЛНЕНИЯ ДВИЖЕНИЙ 
 if (K!=2) {if (f==true){digitalWrite(2,HIGH );}else {digitalWrite(2, LOW);}}// ПЕРЕКЛЮЧЕНИЕ ПОДСВЕТКИ СВЕТОДИОДНОЙ
 if (K==1){F1();}//ШАГ ВПЕРЁД
 if (K==2){delay(n);r++;if(r>25){r=0;}if(f==true&&r>20){r=0;digitalWrite(2,!digitalRead (2));}}//ОСТАНОВКА И МИГАНИЕ ПОДСВЕТКОЙ КОГДА ОНА ВКЛЮЧЕНА
 if (K==3){F2();}//ШАГ НАЗАД
 if (K==4){F4();}//ПОВОРОТ ВПРАВО
 if (K==5){F3();}//ПОВОРОТ ВЛЕВО
 ///////////////////ДВИЖЕНИЕ В АВТОНОМНОМ РЕЖИМЕ ПО УЗ ДАТЧИКУ///////////////////////////
 if (K==6){F1(); digitalWrite(trigPin, HIGH);//излучение звука в течении 15 микросекунд 
  delayMicroseconds(15); 
  digitalWrite(trigPin, LOW); 
  x = pulseIn(echoPin, HIGH,4000);//подсчёт длительности отражённого сигнала с ограничением в 4 мс 
  x1 = x / 58;//дистанция до преграды в сантиметрах
  if(x1>10&&x1<30){byte i1=random(0,2);if(i1==1){F2();F2();F3();F3();F3();F3();}
  else {F2();F2();F4();F4();F4();F4();}}//условие псевдослучайного направления поворота на 4-несколько шагов с отходом назад на 2 шага
  }
  ///////////////////////////////////////////////////////////////////////////////////////
  //F1();//шаг вперёд
  //F2();//шаг назад
  //F3();//шаг-разворот влево
  //F4();//шаг-разворот вправо
}

void F1()
{
  
  /////////////////////////////////////////////  ПРЯМОХОЖДЕНИЕ  /////////////////////////////////////////////
  ///////////// K5,K7 вверх///////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5+i);
  myservoK7.write(a7+i);
  delay(n);}
  ///////////// B6,B8- вперёд B4,B10- назад ////////
   for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6+i);
  myservoB8.write(a8-i);
  myservoB4.write(a4-i);
  myservoB10.write(a10+i);
  delay(n);}
  /////////////K5,K7 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5-i);
  myservoK7.write(a7-i);
  delay(n);}
  ////////////K3,K9 вверх /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3-i);
   myservoK9.write(a9-i);
  delay(n);}
  ///////////// B6,B8- назад B4,B10- вперёд ////////
  for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6-i);
  myservoB8.write(a8+i);
  myservoB4.write(a4+i);
  myservoB10.write(a10-i);
  delay(n);}
  //////////////K3,K9 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3+i);
   myservoK9.write(a9+i);
  delay(n);}
  /////////////////////////////////////////////////////////////////////////////////////////
  
  
 }
void F2()
{
  
  /////////////////////////////////////////////  ДВИЖЕНИЕ НАЗАД  /////////////////////////////////////////////
  ////////////K3,K9 вверх /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3-i);
   myservoK9.write(a9-i);
  delay(n);}
  
  ///////////// B6,B8- вперёд B4,B10- назад ////////
   for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6+i);
  myservoB8.write(a8-i);
  myservoB4.write(a4-i);
  myservoB10.write(a10+i);
  delay(n);}
   //////////////K3,K9 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3+i);
   myservoK9.write(a9+i);
  delay(n);}
  
   ///////////// K5,K7 вверх///////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5+i);
  myservoK7.write(a7+i);
  delay(n);}
  
  ///////////// B6,B8- назад B4,B10- вперёд ////////
  for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6-i);
  myservoB8.write(a8+i);
  myservoB4.write(a4+i);
  myservoB10.write(a10-i);
  delay(n);}
 /////////////K5,K7 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5-i);
  myservoK7.write(a7-i);
  delay(n);}
  /////////////////////////////////////////////////////////////////////////////////////////
  
  
 }

void F3()
{
  
  /////////////////////////////////////////////  РАЗВОРОТ ВЛЕВО  /////////////////////////////////////////////
  ////////////K3,K9 вверх /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3-i);
   myservoK9.write(a9-i);
  delay(n);}
  
  ///////////// B6,B10- вперёд B4,B8- назад ////////
   for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6+i);
  myservoB8.write(a8+i);
  myservoB4.write(a4-i);
  myservoB10.write(a10-i);
  delay(n);}
   //////////////K3,K9 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3+i);
   myservoK9.write(a9+i);
  delay(n);}
  
   ///////////// K5,K7 вверх///////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5+i);
  myservoK7.write(a7+i);
  delay(n);}
  
  ///////////// B6,B10- назад B4,B8- вперёд ////////
  for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6-i);
  myservoB8.write(a8-i);
  myservoB4.write(a4+i);
  myservoB10.write(a10+i);
  delay(n);}
 /////////////K5,K7 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5-i);
  myservoK7.write(a7-i);
  delay(n);}
  /////////////////////////////////////////////////////////////////////////////////////////
  
  
 }

void F4()
{
  
  /////////////////////////////////////////////  РАЗВОРОТ ВПРАВО  /////////////////////////////////////////////
  ///////////// K5,K7 вверх///////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5+i);
  myservoK7.write(a7+i);
  delay(n);}
  ///////////// B6,B10- вперёд B4,B8- назад ////////
   for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6+i);
  myservoB8.write(a8+i);
  myservoB4.write(a4-i);
  myservoB10.write(a10-i);
  delay(n);}
  /////////////K5,K7 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK5.write(a5-i);
  myservoK7.write(a7-i);
  delay(n);}
  ////////////K3,K9 вверх /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3-i);
   myservoK9.write(a9-i);
  delay(n);}
  ///////////// B6,B10- назад B4,B8- вперёд ////////
  for(i = 0 ; i<=db; i++)
  {myservoB6.write(a6-i);
  myservoB8.write(a8-i);
  myservoB4.write(a4+i);
  myservoB10.write(a10+i);
  delay(n);}
  //////////////K3,K9 вниз /////////////
   for(i = 0 ; i<=da; i++)
  {myservoK3.write(a3+i);
   myservoK9.write(a9+i);
  delay(n);}
  /////////////////////////////////////////////////////////////////////////////////////////
  
  
 }
  /////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
//////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
    int y=inputString.length();// присваиваем переменной у число символов в строке
    if (y<1||y>1)return;//если их меньше 1 или больше, выходим из функции
    String cmd=inputString;// передаём строку другой переменной
    inputString = "";//"обнуляем переменную" 
 if (cmd=="1"){K=1;}//ШАГ ВПЕРЁД
 if (cmd=="2"){K=2;}//ОСТАНОВКА 
 if (cmd=="3"){K=3;}//ШАГ НАЗАД
 if (cmd=="4"){K=4;}//ПОВОРОТ ВПРАВО
 if (cmd=="5"){K=5;}//ПОВОРОТ ВЛЕВО
 if (cmd=="6"){n=10;}//ДВИГАЕМСЯ БЫСТРО
 if (cmd=="7"){n=25;}//ДВИГАЕМСЯ МЕДЛЕННО
 if (cmd=="0"){n=15;db=12;}//ВОССТАНАВЛИВАЕМ ИСХОДНЫЕ ПАРАМЕТРЫ ДВИЖЕНИЯ
 if (cmd=="8"){db=20;}//ДВИГАЕМСЯ ШИРОКИМ ШАГОМ
 if (cmd=="9"){db=7;}//ДВИГАЕМСЯ МЕЛКИМ ШАГОМ
 if (cmd=="A"){K=6;}//ДВИГАЕМСЯ В АВТОНОМНОМ РЕЖИМЕ ПО УЗ ДАТЧИКУ
 if (cmd=="S"){f=!f;}//МЕНЯЕМ СОСТОЯНИЕ ФЛАГА НА ПРОТИВОПОЛОЖНОЕ (ВКЛЮЧАЕМ-ВЫКЛЮЧАЕМ СВЕТОДИОДНУЮ ПОДСВЕТКУ)
 }
 
///////////////////////////////////////////////////////////////////////////////////////////////////////

